diff --git a/src/prepare.c b/src/prepare.c
index 9b253adf..09e13d43 100644
--- a/src/prepare.c
+++ b/src/prepare.c
@@ -720,6 +720,8 @@ int pthreads_prepared_startup(pthreads_object_t* thread, pthreads_monitor_t *rea
 
 		if (thread->options & PTHREADS_INHERIT_CLASSES)
 			pthreads_prepare_classes(thread);
+		else pthreads_prepared_entry_static_members(thread, thread->std.ce,
+					pthreads_prepared_entry_internal(thread, thread->std.ce, 0));
 
 		if (thread->options & PTHREADS_INHERIT_INCLUDES)
 			pthreads_prepare_includes(thread);
diff --git a/tests/none-inherited-class-constant.phpt b/tests/none-inherited-class-constant.phpt
new file mode 100644
index 00000000..ecaff3d6
--- /dev/null
+++ b/tests/none-inherited-class-constant.phpt
@@ -0,0 +1,20 @@
+--TEST--
+class constant in NONE_INHERIT thread
+--DESCRIPTION--
+This test ensures that class constants are available inside in NONE_INHERIT threads without error.
+--FILE--
+<?php
+class testClass extends \Thread {
+
+    const TEST_CONSTANT=0x00;
+
+    public function run() {
+        var_dump('works');
+    }
+}
+
+$x = new testClass();
+$x->start(PTHREADS_INHERIT_NONE);
+$x->join();
+--EXPECT--
+string(5) "works"
